From ed3e2da4c598bf4cec89bec8e20a23ab6d82013c Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Fri, 27 May 2016 14:01:59 -0400
Subject: [PATCH 318/319] New VLV indexes for KRA including realm

---
 base/kra/shared/conf/vlv.ldif | 26 +++++++++++++-------------
 1 file changed, 13 insertions(+), 13 deletions(-)

diff --git a/base/kra/shared/conf/vlv.ldif b/base/kra/shared/conf/vlv.ldif
index b619e8657c7b1b0e8d5485f0c00409f94c8dd219..ddb8b4e29c8a71670179dd85ca52e77e8f955c83 100644
--- a/base/kra/shared/conf/vlv.ldif
+++ b/base/kra/shared/conf/vlv.ldif
@@ -4,7 +4,7 @@ objectClass: vlvSearch
 cn: allKeys-{instanceId}
 vlvBase: ou=keyRepository,ou=kra,{rootSuffix}
 vlvScope: 1
-vlvFilter: (&(&(objectClass=top)(objectClass=keyRecord))(serialno=*))
+vlvFilter: (&(serialno=*)(!(realm=*)))
 
 dn: cn=kraAll-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -12,7 +12,7 @@ objectClass: vlvSearch
 cn: kraAll-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (requeststate=*)
+vlvFilter: (&(requeststate=*)(!(realm=*)))
 
 dn: cn=kraArchival-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -20,7 +20,7 @@ objectClass: vlvSearch
 cn: kraArchival-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (requesttype=enrollment)
+vlvFilter: (&(requesttype=enrollment)(!(realm=*)))
 
 dn: cn=kraRecovery-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -28,7 +28,7 @@ objectClass: vlvSearch
 cn: kraRecovery-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (requesttype=recovery)
+vlvFilter: (&(requesttype=recovery)(!(realm=*)))
 
 dn: cn=kraCanceled-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -36,7 +36,7 @@ objectClass: vlvSearch
 cn: kraCanceled-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (requeststate=canceled)
+vlvFilter: (&(requeststate=canceled)(!(realm=*)))
 
 dn: cn=kraCanceledEnrollment-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -44,7 +44,7 @@ objectClass: vlvSearch
 cn: kraCanceledEnrollment-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (&(requeststate=canceled)(requesttype=enrollment))
+vlvFilter: (&(&(requeststate=canceled)(requesttype=enrollment))(!(realm=*)))
 
 dn: cn=kraCanceledRecovery-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -52,7 +52,7 @@ objectClass: vlvSearch
 cn: kraCanceledRecovery-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (&(requeststate=canceled)(requesttype=recovery))
+vlvFilter: (&(&(requeststate=canceled)(requesttype=recovery))(!(realm=*)))
 
 dn: cn=kraRejected-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -60,7 +60,7 @@ objectClass: vlvSearch
 cn: kraRejected-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (requeststate=rejected)
+vlvFilter: (&(requeststate=rejected)(!(realm=*))))
 
 dn: cn=kraRejectedEnrollment-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -68,7 +68,7 @@ objectClass: vlvSearch
 cn: kraRejectedEnrollment-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (&(requeststate=rejected)(requesttype=enrollment))
+vlvFilter: (&(&(requeststate=rejected)(requesttype=enrollment))(!(realm=*)))
 
 dn: cn=kraRejectedRecovery-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -76,7 +76,7 @@ objectClass: vlvSearch
 cn: kraRejectedRecovery-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (&(requeststate=rejected)(requesttype=recovery))
+vlvFilter: (&(&(requeststate=rejected)(requesttype=recovery))(!(realm=*)))
 
 dn: cn=kraComplete-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -84,7 +84,7 @@ objectClass: vlvSearch
 cn: kraComplete-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (requeststate=complete)
+vlvFilter: (&(requeststate=complete)(!(realm=*)))
 
 dn: cn=kraCompleteEnrollment-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -92,7 +92,7 @@ objectClass: vlvSearch
 cn: kraCompleteEnrollment-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (&(requeststate=complete)(requesttype=enrollment))
+vlvFilter: (&(&(requeststate=complete)(requesttype=enrollment))(!(realm=*)))
 
 dn: cn=kraCompleteRecovery-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
@@ -100,7 +100,7 @@ objectClass: vlvSearch
 cn: kraCompleteRecovery-{instanceId}
 vlvBase: ou=kra,ou=requests,{rootSuffix}
 vlvScope: 1
-vlvFilter: (&(requeststate=complete)(requesttype=recovery))
+vlvFilter: (&(&(requeststate=complete)(requesttype=recovery))(!(realm=*)))
 
 dn: cn=allKeys-{instanceId}Index, cn=allKeys-{instanceId}, cn={database}, cn=ldbm database, cn=plugins, cn=config
 objectClass: top
-- 
2.4.3