From ceed7f48be23c2442a21f7c6cb06a6b95b4ce776 Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Mon, 5 Mar 2012 17:23:24 -0800
Subject: [PATCH] Remove all other PKI desktop icons

Bugzilla Bug #745677 - Firefox Launcher on Panel being modified for all users.
---
 pki/base/kra/setup/CMakeLists.txt     |    3 ---
 pki/base/kra/setup/config.desktop.in  |   31 -------------------------------
 pki/base/ocsp/setup/CMakeLists.txt    |    3 ---
 pki/base/ocsp/setup/config.desktop.in |   31 -------------------------------
 pki/base/ra/setup/CMakeLists.txt      |    3 ---
 pki/base/ra/setup/config.desktop.in   |   31 -------------------------------
 pki/base/tks/setup/CMakeLists.txt     |    3 ---
 pki/base/tks/setup/config.desktop.in  |   31 -------------------------------
 pki/base/tps/setup/CMakeLists.txt     |    3 ---
 pki/base/tps/setup/config.desktop.in  |   33 ---------------------------------
 10 files changed, 0 insertions(+), 172 deletions(-)
 delete mode 100644 pki/base/kra/setup/config.desktop.in
 delete mode 100644 pki/base/ocsp/setup/config.desktop.in
 delete mode 100644 pki/base/ra/setup/config.desktop.in
 delete mode 100644 pki/base/tks/setup/config.desktop.in
 delete mode 100644 pki/base/tps/setup/config.desktop.in

diff --git a/pki/base/kra/setup/CMakeLists.txt b/pki/base/kra/setup/CMakeLists.txt
index 25ea20f..f5f069c 100644
--- a/pki/base/kra/setup/CMakeLists.txt
+++ b/pki/base/kra/setup/CMakeLists.txt
@@ -1,10 +1,7 @@
 set(VERSION ${APPLICATION_VERSION})
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/config.desktop @ONLY)
-
 install(
     FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/config.desktop
         registry_instance
     DESTINATION
         ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}/setup
diff --git a/pki/base/kra/setup/config.desktop.in b/pki/base/kra/setup/config.desktop.in
deleted file mode 100644
index 3ca4378..0000000
--- a/pki/base/kra/setup/config.desktop.in
+++ /dev/null
@@ -1,31 +0,0 @@
-# --- BEGIN COPYRIGHT BLOCK ---
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; version 2 of the License.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-#
-# Copyright (C) 2007 Red Hat, Inc.
-# All rights reserved.
-# --- END COPYRIGHT BLOCK ---
-#
-[Desktop Entry]
-Version=@VERSION@
-Encoding=UTF-8
-Name=Data Recovery Manager Configuration - [PKI_INSTANCE_ID]
-GenericName=Data Recovery Manager Configuration
-Comment=Configure Data Recovery Manager
-Exec=firefox https://[PKI_MACHINE_NAME]:[PKI_SECURE_PORT]/kra/admin/console/config/login?pin=[PKI_RANDOM_NUMBER]
-Icon=firefox.png
-Terminal=false
-Type=Application
-MimeType=text/html;text/xml;application/xhtml+xml;application/vnd.mozilla.xul+xml;text/mml;
-X-Desktop-File-Install-Version=0.9
-Categories=Application;CertServer;
diff --git a/pki/base/ocsp/setup/CMakeLists.txt b/pki/base/ocsp/setup/CMakeLists.txt
index 25ea20f..f5f069c 100644
--- a/pki/base/ocsp/setup/CMakeLists.txt
+++ b/pki/base/ocsp/setup/CMakeLists.txt
@@ -1,10 +1,7 @@
 set(VERSION ${APPLICATION_VERSION})
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/config.desktop @ONLY)
-
 install(
     FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/config.desktop
         registry_instance
     DESTINATION
         ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}/setup
diff --git a/pki/base/ocsp/setup/config.desktop.in b/pki/base/ocsp/setup/config.desktop.in
deleted file mode 100644
index be5f5cf..0000000
--- a/pki/base/ocsp/setup/config.desktop.in
+++ /dev/null
@@ -1,31 +0,0 @@
-# --- BEGIN COPYRIGHT BLOCK ---
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; version 2 of the License.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-#
-# Copyright (C) 2007 Red Hat, Inc.
-# All rights reserved.
-# --- END COPYRIGHT BLOCK ---
-#
-[Desktop Entry]
-Version=@VERSION@
-Encoding=UTF-8
-Name=Online Certificate Status Protocol Manager Configuration - [PKI_INSTANCE_ID]
-GenericName=Online Certificate Status Protocol Manager Configuration
-Comment=Configure Online Certificate Status Protocol Manager
-Exec=firefox https://[PKI_MACHINE_NAME]:[PKI_SECURE_PORT]/ocsp/admin/console/config/login?pin=[PKI_RANDOM_NUMBER]
-Icon=firefox.png
-Terminal=false
-Type=Application
-MimeType=text/html;text/xml;application/xhtml+xml;application/vnd.mozilla.xul+xml;text/mml;
-X-Desktop-File-Install-Version=0.9
-Categories=Application;CertServer;
diff --git a/pki/base/ra/setup/CMakeLists.txt b/pki/base/ra/setup/CMakeLists.txt
index 25ea20f..f5f069c 100644
--- a/pki/base/ra/setup/CMakeLists.txt
+++ b/pki/base/ra/setup/CMakeLists.txt
@@ -1,10 +1,7 @@
 set(VERSION ${APPLICATION_VERSION})
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/config.desktop @ONLY)
-
 install(
     FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/config.desktop
         registry_instance
     DESTINATION
         ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}/setup
diff --git a/pki/base/ra/setup/config.desktop.in b/pki/base/ra/setup/config.desktop.in
deleted file mode 100644
index 241f89b..0000000
--- a/pki/base/ra/setup/config.desktop.in
+++ /dev/null
@@ -1,31 +0,0 @@
-# --- BEGIN COPYRIGHT BLOCK ---
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; version 2 of the License.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-#
-# Copyright (C) 2007 Red Hat, Inc.
-# All rights reserved.
-# --- END COPYRIGHT BLOCK ---
-#
-[Desktop Entry]
-Version=@VERSION@
-Encoding=UTF-8
-Name=Registration Authority Configuration - [PKI_INSTANCE_ID]
-GenericName=Registration Authority Configuration
-Comment=Configure Registration Authority
-Exec=firefox https://[SERVER_NAME]:[SECURE_PORT]/ra/admin/console/config/login?pin=[PKI_RANDOM_NUMBER]
-Icon=firefox.png
-Terminal=false
-Type=Application
-MimeType=text/html;text/xml;application/xhtml+xml;application/vnd.mozilla.xul+xml;text/mml;
-X-Desktop-File-Install-Version=0.9
-Categories=Application;CertServer;
diff --git a/pki/base/tks/setup/CMakeLists.txt b/pki/base/tks/setup/CMakeLists.txt
index 25ea20f..f5f069c 100644
--- a/pki/base/tks/setup/CMakeLists.txt
+++ b/pki/base/tks/setup/CMakeLists.txt
@@ -1,10 +1,7 @@
 set(VERSION ${APPLICATION_VERSION})
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/config.desktop @ONLY)
-
 install(
     FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/config.desktop
         registry_instance
     DESTINATION
         ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}/setup
diff --git a/pki/base/tks/setup/config.desktop.in b/pki/base/tks/setup/config.desktop.in
deleted file mode 100644
index d056dad..0000000
--- a/pki/base/tks/setup/config.desktop.in
+++ /dev/null
@@ -1,31 +0,0 @@
-# --- BEGIN COPYRIGHT BLOCK ---
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; version 2 of the License.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-#
-# Copyright (C) 2007 Red Hat, Inc.
-# All rights reserved.
-# --- END COPYRIGHT BLOCK ---
-#
-[Desktop Entry]
-Version=@VERSION@
-Encoding=UTF-8
-Name=Token Key Service Configuration - [PKI_INSTANCE_ID]
-GenericName=Token Key Service Configuration
-Comment=Configure Token Key Service
-Exec=firefox https://[PKI_MACHINE_NAME]:[PKI_SECURE_PORT]/tks/admin/console/config/login?pin=[PKI_RANDOM_NUMBER]
-Icon=firefox.png
-Terminal=false
-Type=Application
-MimeType=text/html;text/xml;application/xhtml+xml;application/vnd.mozilla.xul+xml;text/mml;
-X-Desktop-File-Install-Version=0.9
-Categories=Application;CertServer;
diff --git a/pki/base/tps/setup/CMakeLists.txt b/pki/base/tps/setup/CMakeLists.txt
index 25ea20f..f5f069c 100644
--- a/pki/base/tps/setup/CMakeLists.txt
+++ b/pki/base/tps/setup/CMakeLists.txt
@@ -1,10 +1,7 @@
 set(VERSION ${APPLICATION_VERSION})
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/config.desktop @ONLY)
-
 install(
     FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/config.desktop
         registry_instance
     DESTINATION
         ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}/setup
diff --git a/pki/base/tps/setup/config.desktop.in b/pki/base/tps/setup/config.desktop.in
deleted file mode 100644
index 9ce641b..0000000
--- a/pki/base/tps/setup/config.desktop.in
+++ /dev/null
@@ -1,33 +0,0 @@
-# --- BEGIN COPYRIGHT BLOCK ---
-# This library is free software; you can redistribute it and/or
-# modify it under the terms of the GNU Lesser General Public
-# License as published by the Free Software Foundation;
-# version 2.1 of the License.
-#
-# This library is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-# Lesser General Public License for more details.
-#
-# You should have received a copy of the GNU Lesser General Public
-# License along with this library; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor,
-# Boston, MA  02110-1301  USA
-#
-# Copyright (C) 2007 Red Hat, Inc.
-# All rights reserved.
-# --- END COPYRIGHT BLOCK ---
-#
-[Desktop Entry]
-Version=@VERSION@
-Encoding=UTF-8
-Name=Token Processing System Configuration - [PKI_INSTANCE_ID]
-GenericName=Token Processing System Configuration
-Comment=Configure Token Processing System
-Exec=firefox https://[SERVER_NAME]:[SECURE_PORT]/tps/admin/console/config/login?pin=[PKI_RANDOM_NUMBER]
-Icon=firefox.png
-Terminal=false
-Type=Application
-MimeType=text/html;text/xml;application/xhtml+xml;application/vnd.mozilla.xul+xml;text/mml;
-X-Desktop-File-Install-Version=0.9
-Categories=Application;CertServer;
-- 
1.7.7.6