>From cfc9adad047936a7db6614a0f9e5046ecbc1d10d Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Tue, 20 Nov 2012 10:06:48 -0500
Subject: [PATCH 87/90] Change cmake projects from Java to NONE

---
 base/ca/CMakeLists.txt             | 2 +-
 base/ca/src/CMakeLists.txt         | 2 +-
 base/common/CMakeLists.txt         | 2 +-
 base/common/src/CMakeLists.txt     | 2 +-
 base/common/test/CMakeLists.txt    | 2 +-
 base/console/CMakeLists.txt        | 2 +-
 base/console/src/CMakeLists.txt    | 2 +-
 base/java-tools/CMakeLists.txt     | 2 +-
 base/java-tools/src/CMakeLists.txt | 2 +-
 base/kra/CMakeLists.txt            | 2 +-
 base/kra/src/CMakeLists.txt        | 2 +-
 base/ocsp/CMakeLists.txt           | 2 +-
 base/ocsp/src/CMakeLists.txt       | 2 +-
 base/silent/CMakeLists.txt         | 2 +-
 base/silent/src/CMakeLists.txt     | 2 +-
 base/symkey/src/CMakeLists.txt     | 2 +-
 base/test/CMakeLists.txt           | 2 +-
 base/test/src/CMakeLists.txt       | 2 +-
 base/tks/CMakeLists.txt            | 2 +-
 base/tks/src/CMakeLists.txt        | 2 +-
 base/util/CMakeLists.txt           | 2 +-
 base/util/src/CMakeLists.txt       | 2 +-
 base/util/test/CMakeLists.txt      | 2 +-
 dogtag/console-ui/CMakeLists.txt   | 2 +-
 24 files changed, 24 insertions(+), 24 deletions(-)

diff --git a/base/ca/CMakeLists.txt b/base/ca/CMakeLists.txt
index 153208c2da88b52cd633e3a0df2f5abbc807edc4..9c1616bac282b34f86e9f9a2277bae4edba1a92b 100644
--- a/base/ca/CMakeLists.txt
+++ b/base/ca/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(ca Java)
+project(ca NONE)
 
 add_subdirectory(src)
 add_subdirectory(setup)
diff --git a/base/ca/src/CMakeLists.txt b/base/ca/src/CMakeLists.txt
index 6aa00a75494cfadcd9cc5fb3baae360ebfab7860..f4349efaaec3762eb3dbf96ee1f429f6534d12bb 100644
--- a/base/ca/src/CMakeLists.txt
+++ b/base/ca/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-ca_java Java)
+project(pki-ca_java NONE)
 
 # '/usr/share/java' jars
 find_file(LDAPJDK_JAR
diff --git a/base/common/CMakeLists.txt b/base/common/CMakeLists.txt
index c4a4b1d417aca7645405cf655a30b92edc2c2a3f..73877c82ca51a9dc8fd5b1fe058ce64356de54a0 100644
--- a/base/common/CMakeLists.txt
+++ b/base/common/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(common Java)
+project(common NONE)
 
 # install systemd scripts
 install(
diff --git a/base/common/src/CMakeLists.txt b/base/common/src/CMakeLists.txt
index d5caff43e9b0fd2bb04952f2f9a61b9f389467c3..c589cb184b801f4e5e533629d6c39381e775247c 100644
--- a/base/common/src/CMakeLists.txt
+++ b/base/common/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-certsrv_java Java)
+project(pki-certsrv_java NONE)
 
 find_file(JSS_JAR
     NAMES
diff --git a/base/common/test/CMakeLists.txt b/base/common/test/CMakeLists.txt
index d39b34f54839b417cdc4aa13acb887366fc3637f..7001cfe42f8d36fc1a831799273884c9983bdd42 100644
--- a/base/common/test/CMakeLists.txt
+++ b/base/common/test/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-common-test Java)
+project(pki-common-test NONE)
 
 find_file(PKI_CERTSRV_JAR
     NAMES
diff --git a/base/console/CMakeLists.txt b/base/console/CMakeLists.txt
index 24adfac494ab1b43feedf0d41cd5b30d7abab804..ae70868844cbda42a36c4218cf9dd6ddf08d2012 100644
--- a/base/console/CMakeLists.txt
+++ b/base/console/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(console Java)
+project(console NONE)
 
 add_subdirectory(src)
 add_subdirectory(templates)
diff --git a/base/console/src/CMakeLists.txt b/base/console/src/CMakeLists.txt
index 40f8843a8a4c4556b9d6499927c8f9c04f4acc02..3dc0f5d4152544ecade008362c2fb01a93e97d5c 100644
--- a/base/console/src/CMakeLists.txt
+++ b/base/console/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-console_java Java)
+project(pki-console_java NONE)
 
 # '/usr/share/java/pki' jars
 find_file(PKI_NSUTIL_JAR
diff --git a/base/java-tools/CMakeLists.txt b/base/java-tools/CMakeLists.txt
index 0ba83caa3e8c5c1bb4b4273740fb9e9b74c44e7d..e3024da86d5922645d686690e2a183a113b0f4bb 100644
--- a/base/java-tools/CMakeLists.txt
+++ b/base/java-tools/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(java-tools Java)
+project(java-tools NONE)
 
 
 install(
diff --git a/base/java-tools/src/CMakeLists.txt b/base/java-tools/src/CMakeLists.txt
index 191485667c854aa7af331c978a565b7b533f6f7b..131375bb11592fa9d1b0e192b7c9ea7c57f4fa7c 100644
--- a/base/java-tools/src/CMakeLists.txt
+++ b/base/java-tools/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-tools_java Java)
+project(pki-tools_java NONE)
 
 find_file(JSS_JAR
     NAMES
diff --git a/base/kra/CMakeLists.txt b/base/kra/CMakeLists.txt
index 0e15b2d52e671e6d71c1a478ced0b35751467985..7fc45cdb768febcd45b467049756d519da766a5c 100644
--- a/base/kra/CMakeLists.txt
+++ b/base/kra/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(kra Java)
+project(kra NONE)
 
 add_subdirectory(src)
 add_subdirectory(setup)
diff --git a/base/kra/src/CMakeLists.txt b/base/kra/src/CMakeLists.txt
index 38544dd4155e99bebabbc36ed82a5dd0faa76892..7f570ddc5a9936e068672c255dfa2697c79ca338 100644
--- a/base/kra/src/CMakeLists.txt
+++ b/base/kra/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-kra_java Java)
+project(pki-kra_java NONE)
 
 # '/usr/share/java/pki' jars
 find_file(PKI_CERTSRV_JAR
diff --git a/base/ocsp/CMakeLists.txt b/base/ocsp/CMakeLists.txt
index c8e22ea1e65a1093c82a2fef357c58a48830c477..af6ba8ad0c05a320ef74039263e317c02e923200 100644
--- a/base/ocsp/CMakeLists.txt
+++ b/base/ocsp/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(ocsp Java)
+project(ocsp NONE)
 
 add_subdirectory(src)
 add_subdirectory(setup)
diff --git a/base/ocsp/src/CMakeLists.txt b/base/ocsp/src/CMakeLists.txt
index 2251e9b11208e122b1b40730d51a52854b350b12..36a1908d14a69d99fb5a243d2c704d9c5be414c1 100644
--- a/base/ocsp/src/CMakeLists.txt
+++ b/base/ocsp/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-ocsp_java Java)
+project(pki-ocsp_java NONE)
 
 # '/usr/share/java/pki' jars
 find_file(PKI_CERTSRV_JAR
diff --git a/base/silent/CMakeLists.txt b/base/silent/CMakeLists.txt
index 62da131f65192d1eec63ee248dfe89c9edb6c9d7..f2524e926c4b42045a4c112cc4e042bef812c2d4 100644
--- a/base/silent/CMakeLists.txt
+++ b/base/silent/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(silent Java)
+project(silent NONE)
 
 add_subdirectory(src)
 add_subdirectory(scripts)
diff --git a/base/silent/src/CMakeLists.txt b/base/silent/src/CMakeLists.txt
index 72be415bde49c365ae1b6346e14785c1da42bd78..56809caac0aac311832222bcc9d0bc0868218c02 100644
--- a/base/silent/src/CMakeLists.txt
+++ b/base/silent/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-silent_java Java)
+project(pki-silent_java NONE)
 
 find_file(JSS_JAR
     NAMES
diff --git a/base/symkey/src/CMakeLists.txt b/base/symkey/src/CMakeLists.txt
index 149247599e87ac2d573d563a7aa56d347506af89..9a4e10fdaa78ce6b7023b83f144b4039616f3216 100644
--- a/base/symkey/src/CMakeLists.txt
+++ b/base/symkey/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(symkey Java)
+project(symkey NONE)
 
 find_file(JSS_JAR
     NAMES
diff --git a/base/test/CMakeLists.txt b/base/test/CMakeLists.txt
index 9a4acceefea18130a011b750b17d7aabdabf88d5..8a85e3be98b2e957df76d75fdf4d3dc772f9adad 100644
--- a/base/test/CMakeLists.txt
+++ b/base/test/CMakeLists.txt
@@ -1,3 +1,3 @@
-project(test Java)
+project(test NONE)
 
 add_subdirectory(src)
diff --git a/base/test/src/CMakeLists.txt b/base/test/src/CMakeLists.txt
index 5e7c12d6448191bdc9475d4b3aa3911f5041696a..6133ff37c2aebee0f0341ff749f9c292a01c7321 100644
--- a/base/test/src/CMakeLists.txt
+++ b/base/test/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-test_java Java)
+project(pki-test_java NONE)
 
 # build pki-test
 # TODO: build test only when the test is invoked
diff --git a/base/tks/CMakeLists.txt b/base/tks/CMakeLists.txt
index fd9246948e4798455467444583b696acacd476df..a503f2401666d78941cb573bdd7461b1ef532296 100644
--- a/base/tks/CMakeLists.txt
+++ b/base/tks/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(tks Java)
+project(tks NONE)
 
 add_subdirectory(src)
 add_subdirectory(setup)
diff --git a/base/tks/src/CMakeLists.txt b/base/tks/src/CMakeLists.txt
index 522d1dc0610dba47bc127df5b6de3bdc79368486..cf82ccc50f032c113ab28590936adea9586b1d52 100644
--- a/base/tks/src/CMakeLists.txt
+++ b/base/tks/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-tks_java Java)
+project(pki-tks_java NONE)
 
 # '/usr/share/java/pki' jars
 find_file(PKI_CERTSRV_JAR
diff --git a/base/util/CMakeLists.txt b/base/util/CMakeLists.txt
index b8600ba4cbd1351f21aa64b6afd8dee88de9c009..94e30cc87fbfa2e94a48414fdc0b27a80f3276b6 100644
--- a/base/util/CMakeLists.txt
+++ b/base/util/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(util Java)
+project(util NONE)
 
 add_subdirectory(src)
 add_subdirectory(test)
diff --git a/base/util/src/CMakeLists.txt b/base/util/src/CMakeLists.txt
index 767db7d691c0bd52a14d522532c523b615a6f4ed..35b8e0a5b55f903876c2f48b1d23feef43ea1bdf 100644
--- a/base/util/src/CMakeLists.txt
+++ b/base/util/src/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-cmsutil_java Java)
+project(pki-cmsutil_java NONE)
 
 find_file(APACHE_COMMONS_LANG_JAR
     NAMES
diff --git a/base/util/test/CMakeLists.txt b/base/util/test/CMakeLists.txt
index fdb97e5a1ab1c386a31c6c6eaa219d75060bc633..2cf7b50aa8817183a4d3506a8acab3cf8d891fc2 100644
--- a/base/util/test/CMakeLists.txt
+++ b/base/util/test/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(pki-util-test Java)
+project(pki-util-test NONE)
 
 # build pki-util-test
 # TODO: build test only when the test is invoked
diff --git a/dogtag/console-ui/CMakeLists.txt b/dogtag/console-ui/CMakeLists.txt
index fcb7bf40e9a1ff55878358a0879ed21848b7e114..01e8d6d20afa709e876e5a812e0ef517dc77d838 100644
--- a/dogtag/console-ui/CMakeLists.txt
+++ b/dogtag/console-ui/CMakeLists.txt
@@ -1,3 +1,3 @@
-project(console-ui Java)
+project(console-ui NONE)
 
 add_subdirectory(src)
-- 
1.7.11.7